package org.util

import org.eclipse.emf.ecore.EObject
import org.eclipse.emf.ecore.resource.Resource

class AST {
	Resource resource;
	
	new(Resource resource){
		this.resource = resource;
	}
	
	def String getAST(){
		val contents = resource.allContents;
		val root = contents.toIterable.get(0);
        var tree = new String("");
        tree = getNode(root,tree);
        return tree;
	}
	
	private def String getNode(EObject node,String tree){
		//get rule name
		var newTree = tree + node.toString.replaceFirst ('.*[.]impl[.](.*)Impl[^(]*', '$1 ');
	    for (ext :node.eCrossReferences)
	        newTree += ' ->' + ext.toString.replaceFirst ('.*[.]impl[.](.*)Impl[^(]*', '$1 ');
	    newTree += "\n";
	    for (child :node.eContents) {
	        newTree += child.getNode(tree+"    ");
	    }
    	return newTree;
    }
}