/*
 * generated by Xtext 2.24.0
 */
package org.serializer;

import com.google.inject.Inject;
import java.util.Set;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.xtext.Action;
import org.eclipse.xtext.Parameter;
import org.eclipse.xtext.ParserRule;
import org.eclipse.xtext.serializer.ISerializationContext;
import org.eclipse.xtext.serializer.acceptor.SequenceFeeder;
import org.eclipse.xtext.serializer.sequencer.AbstractDelegatingSemanticSequencer;
import org.eclipse.xtext.serializer.sequencer.ITransientValueService.ValueTransient;
import org.services.TestScriptDSLGrammarAccess;
import org.testScriptDSL.AbstractElement;
import org.testScriptDSL.AddAndSub;
import org.testScriptDSL.Array;
import org.testScriptDSL.Dot;
import org.testScriptDSL.Euqal;
import org.testScriptDSL.Exp;
import org.testScriptDSL.Import;
import org.testScriptDSL.MulAndDiv;
import org.testScriptDSL.Ret;
import org.testScriptDSL.Stmt;
import org.testScriptDSL.TestScriptDSL;
import org.testScriptDSL.TestScriptDSLPackage;
import org.testScriptDSL.Val;
import org.testScriptDSL.Var;
import org.testScriptDSL.VarDec;

@SuppressWarnings("all")
public class TestScriptDSLSemanticSequencer extends AbstractDelegatingSemanticSequencer {

	@Inject
	private TestScriptDSLGrammarAccess grammarAccess;
	
	@Override
	public void sequence(ISerializationContext context, EObject semanticObject) {
		EPackage epackage = semanticObject.eClass().getEPackage();
		ParserRule rule = context.getParserRule();
		Action action = context.getAssignedAction();
		Set<Parameter> parameters = context.getEnabledBooleanParameters();
		if (epackage == TestScriptDSLPackage.eINSTANCE)
			switch (semanticObject.eClass().getClassifierID()) {
			case TestScriptDSLPackage.ABSTRACT_ELEMENT:
				sequence_AbstractElement(context, (AbstractElement) semanticObject); 
				return; 
			case TestScriptDSLPackage.ADD_AND_SUB:
				sequence_AddAndSub(context, (AddAndSub) semanticObject); 
				return; 
			case TestScriptDSLPackage.ARRAY:
				sequence_Array(context, (Array) semanticObject); 
				return; 
			case TestScriptDSLPackage.DOT:
				sequence_Dot(context, (Dot) semanticObject); 
				return; 
			case TestScriptDSLPackage.EUQAL:
				sequence_Equal(context, (Euqal) semanticObject); 
				return; 
			case TestScriptDSLPackage.EXP:
				if (rule == grammarAccess.getAddAndSubRule()
						|| action == grammarAccess.getAddAndSubAccess().getAddAndSubLeftAction_1_0()) {
					sequence_AddAndSub(context, (Exp) semanticObject); 
					return; 
				}
				else if (rule == grammarAccess.getArrayRule()
						|| action == grammarAccess.getArrayAccess().getArrayLeftAction_1_0()) {
					sequence_Array(context, (Exp) semanticObject); 
					return; 
				}
				else if (rule == grammarAccess.getDotRule()
						|| action == grammarAccess.getDotAccess().getDotLeftAction_1_0()) {
					sequence_Dot(context, (Exp) semanticObject); 
					return; 
				}
				else if (rule == grammarAccess.getEqualRule()
						|| action == grammarAccess.getEqualAccess().getEuqalLeftAction_1_0()) {
					sequence_Equal(context, (Exp) semanticObject); 
					return; 
				}
				else if (rule == grammarAccess.getExpRule()) {
					sequence_Exp(context, (Exp) semanticObject); 
					return; 
				}
				else if (rule == grammarAccess.getMulAndDivRule()
						|| action == grammarAccess.getMulAndDivAccess().getMulAndDivLeftAction_1_0()) {
					sequence_MulAndDiv(context, (Exp) semanticObject); 
					return; 
				}
				else if (rule == grammarAccess.getPrimaryRule()) {
					sequence_Primary(context, (Exp) semanticObject); 
					return; 
				}
				else break;
			case TestScriptDSLPackage.IMPORT:
				sequence_Import(context, (Import) semanticObject); 
				return; 
			case TestScriptDSLPackage.MUL_AND_DIV:
				sequence_MulAndDiv(context, (MulAndDiv) semanticObject); 
				return; 
			case TestScriptDSLPackage.RET:
				sequence_Ret(context, (Ret) semanticObject); 
				return; 
			case TestScriptDSLPackage.STMT:
				sequence_Stmt(context, (Stmt) semanticObject); 
				return; 
			case TestScriptDSLPackage.TEST_SCRIPT_DSL:
				sequence_TestScriptDSL(context, (TestScriptDSL) semanticObject); 
				return; 
			case TestScriptDSLPackage.VAL:
				sequence_Val(context, (Val) semanticObject); 
				return; 
			case TestScriptDSLPackage.VAR:
				sequence_Var(context, (Var) semanticObject); 
				return; 
			case TestScriptDSLPackage.VAR_DEC:
				sequence_VarDec(context, (VarDec) semanticObject); 
				return; 
			}
		if (errorAcceptor != null)
			errorAcceptor.accept(diagnosticProvider.createInvalidContextOrTypeDiagnostic(semanticObject, context));
	}
	
	/**
	 * Contexts:
	 *     AbstractElement returns AbstractElement
	 *
	 * Constraint:
	 *     stmt=Stmt
	 */
	protected void sequence_AbstractElement(ISerializationContext context, AbstractElement semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, TestScriptDSLPackage.Literals.ABSTRACT_ELEMENT__STMT) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, TestScriptDSLPackage.Literals.ABSTRACT_ELEMENT__STMT));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getAbstractElementAccess().getStmtStmtParserRuleCall_0(), semanticObject.getStmt());
		feeder.finish();
	}
	
	
	/**
	 * Contexts:
	 *     AddAndSub returns AddAndSub
	 *     AddAndSub.AddAndSub_1_0 returns AddAndSub
	 *
	 * Constraint:
	 *     (left=AddAndSub_AddAndSub_1_0 (op='+' | op='-') right=MulAndDiv)
	 */
	protected void sequence_AddAndSub(ISerializationContext context, AddAndSub semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     AddAndSub returns Exp
	 *     AddAndSub.AddAndSub_1_0 returns Exp
	 *
	 * Constraint:
	 *     left=MulAndDiv
	 */
	protected void sequence_AddAndSub(ISerializationContext context, Exp semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, TestScriptDSLPackage.Literals.EXP__LEFT) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, TestScriptDSLPackage.Literals.EXP__LEFT));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getAddAndSubAccess().getLeftMulAndDivParserRuleCall_0_0(), semanticObject.getLeft());
		feeder.finish();
	}
	
	
	/**
	 * Contexts:
	 *     Array returns Array
	 *     Array.Array_1_0 returns Array
	 *
	 * Constraint:
	 *     (left=Array_Array_1_0 op='[' right=Primary)
	 */
	protected void sequence_Array(ISerializationContext context, Array semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, TestScriptDSLPackage.Literals.EXP__LEFT) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, TestScriptDSLPackage.Literals.EXP__LEFT));
			if (transientValues.isValueTransient(semanticObject, TestScriptDSLPackage.Literals.EXP__OP) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, TestScriptDSLPackage.Literals.EXP__OP));
			if (transientValues.isValueTransient(semanticObject, TestScriptDSLPackage.Literals.EXP__RIGHT) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, TestScriptDSLPackage.Literals.EXP__RIGHT));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getArrayAccess().getArrayLeftAction_1_0(), semanticObject.getLeft());
		feeder.accept(grammarAccess.getArrayAccess().getOpLeftSquareBracketKeyword_1_1_0(), semanticObject.getOp());
		feeder.accept(grammarAccess.getArrayAccess().getRightPrimaryParserRuleCall_1_2_0(), semanticObject.getRight());
		feeder.finish();
	}
	
	
	/**
	 * Contexts:
	 *     Array returns Exp
	 *     Array.Array_1_0 returns Exp
	 *
	 * Constraint:
	 *     left=Primary
	 */
	protected void sequence_Array(ISerializationContext context, Exp semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, TestScriptDSLPackage.Literals.EXP__LEFT) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, TestScriptDSLPackage.Literals.EXP__LEFT));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getArrayAccess().getLeftPrimaryParserRuleCall_0_0(), semanticObject.getLeft());
		feeder.finish();
	}
	
	
	/**
	 * Contexts:
	 *     Dot returns Dot
	 *     Dot.Dot_1_0 returns Dot
	 *
	 * Constraint:
	 *     (left=Dot_Dot_1_0 op='.' right=Array)
	 */
	protected void sequence_Dot(ISerializationContext context, Dot semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, TestScriptDSLPackage.Literals.EXP__LEFT) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, TestScriptDSLPackage.Literals.EXP__LEFT));
			if (transientValues.isValueTransient(semanticObject, TestScriptDSLPackage.Literals.EXP__OP) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, TestScriptDSLPackage.Literals.EXP__OP));
			if (transientValues.isValueTransient(semanticObject, TestScriptDSLPackage.Literals.EXP__RIGHT) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, TestScriptDSLPackage.Literals.EXP__RIGHT));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getDotAccess().getDotLeftAction_1_0(), semanticObject.getLeft());
		feeder.accept(grammarAccess.getDotAccess().getOpFullStopKeyword_1_1_0(), semanticObject.getOp());
		feeder.accept(grammarAccess.getDotAccess().getRightArrayParserRuleCall_1_2_0(), semanticObject.getRight());
		feeder.finish();
	}
	
	
	/**
	 * Contexts:
	 *     Dot returns Exp
	 *     Dot.Dot_1_0 returns Exp
	 *
	 * Constraint:
	 *     left=Array
	 */
	protected void sequence_Dot(ISerializationContext context, Exp semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, TestScriptDSLPackage.Literals.EXP__LEFT) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, TestScriptDSLPackage.Literals.EXP__LEFT));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getDotAccess().getLeftArrayParserRuleCall_0_0(), semanticObject.getLeft());
		feeder.finish();
	}
	
	
	/**
	 * Contexts:
	 *     Equal returns Euqal
	 *     Equal.Euqal_1_0 returns Euqal
	 *
	 * Constraint:
	 *     (left=Equal_Euqal_1_0 op='=' right=AddAndSub)
	 */
	protected void sequence_Equal(ISerializationContext context, Euqal semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, TestScriptDSLPackage.Literals.EXP__LEFT) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, TestScriptDSLPackage.Literals.EXP__LEFT));
			if (transientValues.isValueTransient(semanticObject, TestScriptDSLPackage.Literals.EXP__OP) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, TestScriptDSLPackage.Literals.EXP__OP));
			if (transientValues.isValueTransient(semanticObject, TestScriptDSLPackage.Literals.EXP__RIGHT) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, TestScriptDSLPackage.Literals.EXP__RIGHT));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getEqualAccess().getEuqalLeftAction_1_0(), semanticObject.getLeft());
		feeder.accept(grammarAccess.getEqualAccess().getOpEqualsSignKeyword_1_1_0(), semanticObject.getOp());
		feeder.accept(grammarAccess.getEqualAccess().getRightAddAndSubParserRuleCall_1_2_0(), semanticObject.getRight());
		feeder.finish();
	}
	
	
	/**
	 * Contexts:
	 *     Equal returns Exp
	 *     Equal.Euqal_1_0 returns Exp
	 *
	 * Constraint:
	 *     left=AddAndSub
	 */
	protected void sequence_Equal(ISerializationContext context, Exp semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, TestScriptDSLPackage.Literals.EXP__LEFT) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, TestScriptDSLPackage.Literals.EXP__LEFT));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getEqualAccess().getLeftAddAndSubParserRuleCall_0_0(), semanticObject.getLeft());
		feeder.finish();
	}
	
	
	/**
	 * Contexts:
	 *     Exp returns Exp
	 *
	 * Constraint:
	 *     left=Equal
	 */
	protected void sequence_Exp(ISerializationContext context, Exp semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, TestScriptDSLPackage.Literals.EXP__LEFT) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, TestScriptDSLPackage.Literals.EXP__LEFT));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getExpAccess().getLeftEqualParserRuleCall_0(), semanticObject.getLeft());
		feeder.finish();
	}
	
	
	/**
	 * Contexts:
	 *     Import returns Import
	 *
	 * Constraint:
	 *     importedNamespace=QualifiedNameWithWildcard
	 */
	protected void sequence_Import(ISerializationContext context, Import semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, TestScriptDSLPackage.Literals.IMPORT__IMPORTED_NAMESPACE) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, TestScriptDSLPackage.Literals.IMPORT__IMPORTED_NAMESPACE));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getImportAccess().getImportedNamespaceQualifiedNameWithWildcardParserRuleCall_1_0(), semanticObject.getImportedNamespace());
		feeder.finish();
	}
	
	
	/**
	 * Contexts:
	 *     MulAndDiv returns Exp
	 *     MulAndDiv.MulAndDiv_1_0 returns Exp
	 *
	 * Constraint:
	 *     left=Dot
	 */
	protected void sequence_MulAndDiv(ISerializationContext context, Exp semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, TestScriptDSLPackage.Literals.EXP__LEFT) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, TestScriptDSLPackage.Literals.EXP__LEFT));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getMulAndDivAccess().getLeftDotParserRuleCall_0_0(), semanticObject.getLeft());
		feeder.finish();
	}
	
	
	/**
	 * Contexts:
	 *     MulAndDiv returns MulAndDiv
	 *     MulAndDiv.MulAndDiv_1_0 returns MulAndDiv
	 *
	 * Constraint:
	 *     (left=MulAndDiv_MulAndDiv_1_0 (op='*' | op='/') right=Dot)
	 */
	protected void sequence_MulAndDiv(ISerializationContext context, MulAndDiv semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Primary returns Exp
	 *
	 * Constraint:
	 *     ((op='(' left=Equal) | left=Var | left=Val)
	 */
	protected void sequence_Primary(ISerializationContext context, Exp semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Ret returns Ret
	 *
	 * Constraint:
	 *     name=ID
	 */
	protected void sequence_Ret(ISerializationContext context, Ret semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, TestScriptDSLPackage.Literals.RET__NAME) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, TestScriptDSLPackage.Literals.RET__NAME));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getRetAccess().getNameIDTerminalRuleCall_1_0(), semanticObject.getName());
		feeder.finish();
	}
	
	
	/**
	 * Contexts:
	 *     Stmt returns Stmt
	 *
	 * Constraint:
	 *     (type=Exp | type=Import)
	 */
	protected void sequence_Stmt(ISerializationContext context, Stmt semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     TestScriptDSL returns TestScriptDSL
	 *
	 * Constraint:
	 *     elements+=AbstractElement+
	 */
	protected void sequence_TestScriptDSL(ISerializationContext context, TestScriptDSL semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Val returns Val
	 *
	 * Constraint:
	 *     name=QualifiedValue
	 */
	protected void sequence_Val(ISerializationContext context, Val semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, TestScriptDSLPackage.Literals.VAL__NAME) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, TestScriptDSLPackage.Literals.VAL__NAME));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getValAccess().getNameQualifiedValueParserRuleCall_0(), semanticObject.getName());
		feeder.finish();
	}
	
	
	/**
	 * Contexts:
	 *     VarDec returns VarDec
	 *
	 * Constraint:
	 *     (name=ID index=QualifiedIndex? value=QualifiedValue)
	 */
	protected void sequence_VarDec(ISerializationContext context, VarDec semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Var returns Var
	 *
	 * Constraint:
	 *     name=ID
	 */
	protected void sequence_Var(ISerializationContext context, Var semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, TestScriptDSLPackage.Literals.VAR__NAME) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, TestScriptDSLPackage.Literals.VAR__NAME));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getVarAccess().getNameIDTerminalRuleCall_0(), semanticObject.getName());
		feeder.finish();
	}
	
	
}
