/*
 * generated by Xtext 2.24.0
 */
package org.generator

import org.eclipse.emf.ecore.resource.Resource
import org.eclipse.xtext.generator.AbstractGenerator
import org.eclipse.xtext.generator.IFileSystemAccess2
import org.eclipse.xtext.generator.IGeneratorContext
import org.testScriptDSL.Stmt
import org.testScriptDSL.TestScriptDSL
import org.testScriptDSL.AbstractElement
import org.testScriptDSL.Exp
import org.testScriptDSL.Import
//import org.util.AST
import org.testScriptDSL.Var
import org.testScriptDSL.Val

/**
 * Generates code from your model files on save.
 * 
 * See https://www.eclipse.org/Xtext/documentation/303_runtime_concepts.html#code-generation
 */
class TestScriptDSLGenerator extends AbstractGenerator {

	override void doGenerate(Resource resource, IFileSystemAccess2 fsa, IGeneratorContext context) {
		for (dsl : resource.allContents.toIterable.filter(TestScriptDSL)) {
	            fsa.generateFile(
	                "testcase.py",
	                dsl.compile)
	        }
	        /*
	    var ast = new AST(resource);
        var tree = ast.getAST();
        System.out.println(tree);
		*/
	}
		
	private def compile(TestScriptDSL dsl) '''
        «FOR e : dsl.elements»
            «e.compile»
        «ENDFOR»
    '''
    
    private def compile(AbstractElement e) '''
    	«e.stmt.compile»
    '''
    
    private def compile(Stmt s) '''
        «IF s.type instanceof Import»
        «(s.type as Import).compile
        »«ELSEIF s.type instanceof Exp
        »«(s.type as Exp).compile
        »«ENDIF»'''
   	
   	
         /*   		
    private def CharSequence compile(Exp e) {
		'''
		«IF e.left !== null»
			«IF e.left instanceof Var
			»«(e.left as Var).compile
			»«ELSEIF e.left instanceof Val
			»«(e.left as Val).compile
			»«ELSE
				»«(e.left as Exp).compile
				»«IF e.op == '[' || e.op == '(' || e.op == '.'
				»«e.op»«ELSE
				» «e.op» «ENDIF
				»«IF e.right !== null
				»«(e.right as Exp).compile
				»«ENDIF
				»«IF e.op == '['»]«ELSEIF e.op=='('»)«ENDIF
				»«ENDIF
				»«ENDIF»'''
		}
		*/
	
	private def CharSequence compile(Exp e) {
			if(e.left !== null) {
				if (e.left instanceof Var){
					'''«(e.left as Var).compile»'''
				}
				else if (e.left instanceof Val) {
					'''«(e.left as Val).compile»'''
				}
				else {
					'''
					«(e.left as Exp).compile
					»«IF (e.op == '[' || e.op == '(' || e.op == '.')
					»«e.op»
					«ELSE» «e.op» «ENDIF»
					«IF (e.right !== null)»«(e.right as Exp).compile»«ENDIF»'''
				}
			}
		}
		
   	private def compile(Var v) 
   	'''«v.name»'''
   	
   	private def compile(Val v) 
   	'''«v.name»'''
   	
   	private def compile(Import ip) '''
   		import «ip.importedNamespace»
   	'''
   	
}


