/**
 * generated by Xtext 2.24.0
 */
package org.generator;

import com.google.common.base.Objects;
import com.google.common.collect.Iterables;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.xtend2.lib.StringConcatenation;
import org.eclipse.xtext.generator.AbstractGenerator;
import org.eclipse.xtext.generator.IFileSystemAccess2;
import org.eclipse.xtext.generator.IGeneratorContext;
import org.eclipse.xtext.xbase.lib.IteratorExtensions;
import org.testScriptDSL.AbstractElement;
import org.testScriptDSL.Exp;
import org.testScriptDSL.Import;
import org.testScriptDSL.Stmt;
import org.testScriptDSL.TestScriptDSL;
import org.testScriptDSL.Val;
import org.testScriptDSL.Var;

/**
 * Generates code from your model files on save.
 * 
 * See https://www.eclipse.org/Xtext/documentation/303_runtime_concepts.html#code-generation
 */
@SuppressWarnings("all")
public class TestScriptDSLGenerator extends AbstractGenerator {
  @Override
  public void doGenerate(final Resource resource, final IFileSystemAccess2 fsa, final IGeneratorContext context) {
    Iterable<TestScriptDSL> _filter = Iterables.<TestScriptDSL>filter(IteratorExtensions.<EObject>toIterable(resource.getAllContents()), TestScriptDSL.class);
    for (final TestScriptDSL dsl : _filter) {
      fsa.generateFile(
        "testcase.py", 
        this.compile(dsl));
    }
  }
  
  private CharSequence compile(final TestScriptDSL dsl) {
    StringConcatenation _builder = new StringConcatenation();
    {
      EList<AbstractElement> _elements = dsl.getElements();
      for(final AbstractElement e : _elements) {
        CharSequence _compile = this.compile(e);
        _builder.append(_compile);
        _builder.newLineIfNotEmpty();
      }
    }
    return _builder;
  }
  
  private CharSequence compile(final AbstractElement e) {
    StringConcatenation _builder = new StringConcatenation();
    CharSequence _compile = this.compile(e.getStmt());
    _builder.append(_compile);
    _builder.newLineIfNotEmpty();
    return _builder;
  }
  
  private CharSequence compile(final Stmt s) {
    StringConcatenation _builder = new StringConcatenation();
    {
      EObject _type = s.getType();
      if ((_type instanceof Import)) {
        EObject _type_1 = s.getType();
        CharSequence _compile = this.compile(((Import) _type_1));
        _builder.append(_compile);
      } else {
        EObject _type_2 = s.getType();
        if ((_type_2 instanceof Exp)) {
          EObject _type_3 = s.getType();
          CharSequence _compile_1 = this.compile(((Exp) _type_3));
          _builder.append(_compile_1);
        }
      }
    }
    return _builder;
  }
  
  /**
   * private def CharSequence compile(Exp e) {
   * '''
   * \u00abIF e.left !== null\u00bb
   * \u00abIF e.left instanceof Var
   * \u00bb\u00ab(e.left as Var).compile
   * \u00bb\u00abELSEIF e.left instanceof Val
   * \u00bb\u00ab(e.left as Val).compile
   * \u00bb\u00abELSE
   * \u00bb\u00ab(e.left as Exp).compile
   * \u00bb\u00abIF e.op == '[' || e.op == '(' || e.op == '.'
   * \u00bb\u00abe.op\u00bb\u00abELSE
   * \u00bb \u00abe.op\u00bb \u00abENDIF
   * \u00bb\u00abIF e.right !== null
   * \u00bb\u00ab(e.right as Exp).compile
   * \u00bb\u00abENDIF
   * \u00bb\u00abIF e.op == '['\u00bb]\u00abELSEIF e.op=='('\u00bb)\u00abENDIF
   * \u00bb\u00abENDIF
   * \u00bb\u00abENDIF\u00bb'''
   * }
   */
  private CharSequence compile(final Exp e) {
    CharSequence _xifexpression = null;
    EObject _left = e.getLeft();
    boolean _tripleNotEquals = (_left != null);
    if (_tripleNotEquals) {
      CharSequence _xifexpression_1 = null;
      EObject _left_1 = e.getLeft();
      if ((_left_1 instanceof Var)) {
        StringConcatenation _builder = new StringConcatenation();
        EObject _left_2 = e.getLeft();
        CharSequence _compile = this.compile(((Var) _left_2));
        _builder.append(_compile);
        _xifexpression_1 = _builder;
      } else {
        CharSequence _xifexpression_2 = null;
        EObject _left_3 = e.getLeft();
        if ((_left_3 instanceof Val)) {
          StringConcatenation _builder_1 = new StringConcatenation();
          EObject _left_4 = e.getLeft();
          CharSequence _compile_1 = this.compile(((Val) _left_4));
          _builder_1.append(_compile_1);
          _xifexpression_2 = _builder_1;
        } else {
          StringConcatenation _builder_2 = new StringConcatenation();
          EObject _left_5 = e.getLeft();
          CharSequence _compile_2 = this.compile(((Exp) _left_5));
          _builder_2.append(_compile_2);
          {
            if (((Objects.equal(e.getOp(), "[") || Objects.equal(e.getOp(), "(")) || Objects.equal(e.getOp(), "."))) {
              String _op = e.getOp();
              _builder_2.append(_op);
              _builder_2.newLineIfNotEmpty();
            } else {
              _builder_2.append(" ");
              String _op_1 = e.getOp();
              _builder_2.append(_op_1);
              _builder_2.append(" ");
            }
          }
          _builder_2.newLineIfNotEmpty();
          {
            Exp _right = e.getRight();
            boolean _tripleNotEquals_1 = (_right != null);
            if (_tripleNotEquals_1) {
              Exp _right_1 = e.getRight();
              CharSequence _compile_3 = this.compile(((Exp) _right_1));
              _builder_2.append(_compile_3);
            }
          }
          _xifexpression_2 = _builder_2;
        }
        _xifexpression_1 = _xifexpression_2;
      }
      _xifexpression = _xifexpression_1;
    }
    return _xifexpression;
  }
  
  private CharSequence compile(final Var v) {
    StringConcatenation _builder = new StringConcatenation();
    String _name = v.getName();
    _builder.append(_name);
    return _builder;
  }
  
  private CharSequence compile(final Val v) {
    StringConcatenation _builder = new StringConcatenation();
    String _name = v.getName();
    _builder.append(_name);
    return _builder;
  }
  
  private CharSequence compile(final Import ip) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("import ");
    String _importedNamespace = ip.getImportedNamespace();
    _builder.append(_importedNamespace);
    _builder.newLineIfNotEmpty();
    return _builder;
  }
}
