package org.util;

import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.common.util.TreeIterator;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.xtext.xbase.lib.Conversions;
import org.eclipse.xtext.xbase.lib.IteratorExtensions;

@SuppressWarnings("all")
public class AST {
  private Resource resource;
  
  public AST(final Resource resource) {
    this.resource = resource;
  }
  
  public String getAST() {
    final TreeIterator<EObject> contents = this.resource.getAllContents();
    final EObject root = ((EObject[])Conversions.unwrapArray(IteratorExtensions.<EObject>toIterable(contents), EObject.class))[0];
    String tree = new String("");
    tree = this.getNode(root, tree);
    return tree;
  }
  
  private String getNode(final EObject node, final String tree) {
    String _replaceFirst = node.toString().replaceFirst(".*[.]impl[.](.*)Impl[^(]*", "$1 ");
    String newTree = (tree + _replaceFirst);
    EList<EObject> _eCrossReferences = node.eCrossReferences();
    for (final EObject ext : _eCrossReferences) {
      String _newTree = newTree;
      String _replaceFirst_1 = ext.toString().replaceFirst(".*[.]impl[.](.*)Impl[^(]*", "$1 ");
      String _plus = (" ->" + _replaceFirst_1);
      newTree = (_newTree + _plus);
    }
    String _newTree_1 = newTree;
    newTree = (_newTree_1 + "\n");
    EList<EObject> _eContents = node.eContents();
    for (final EObject child : _eContents) {
      String _newTree_2 = newTree;
      String _node = this.getNode(child, (tree + "    "));
      newTree = (_newTree_2 + _node);
    }
    return newTree;
  }
}
